//+------------------------------------------------------------------+
//|                                               MetroPitchfork.mq4 |
//|                                                            Talex |
//|                                                 tan@gazinter.net |
//+------------------------------------------------------------------+
#property copyright "Talex"
#property link      "tan@gazinter.net"

#property indicator_chart_window
#import "user32.dll"
int GetClientRect(int hWnd,int lpRect[]);
#import

extern string txt1 = " ---   ---";
extern int ExtPoint=3; /*    ,    3,        */
extern double Scale=0; //     .
extern int ExtArcStyle=0; /*     */ 
extern int ExtArcWidth=1; /*     */
extern color ExtArcColor=Red; /*   */
//extern int MetodScale=1; //  Scale=0,   

extern string txt2 = " ---   ZigZag ---";
extern int ExtDepth = 26;
extern int ExtDeviation = 5;
extern int ExtBackstep = 3;


static int GPixels,VPixels;
int rect[4],hwnd;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   hwnd=WindowHandle(Symbol(),Period());
   if(hwnd>0)
   {
     GetClientRect(hwnd,rect);
     GPixels=rect[2]; //    -   
     VPixels=rect[3]; //    -   
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("MetroPitchfork");
   ObjectDelete("MetroArc");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,j,zzbar[];
   double zz,zzp[],tp,k,b,medpr;
   datetime medtm,newbar;
//----
   if(newbar!=Time[0])
   {
     newbar=Time[0];
     ArrayResize(zzbar,ExtPoint); 
     ArrayResize(zzp,ExtPoint); 
   
//   
     for(i=0,j=0;i<Bars && j<ExtPoint;i++)
     {
       zz=iCustom(NULL,0,"ZigZag",ExtDepth,ExtDeviation,ExtBackstep,0,i);
       if(zz!=0)
       {
         zzbar[j]=i;
         zzp[j]=zz;
         j++;
       }
     }
//    
     medpr=zzp[ExtPoint-3]+zzp[ExtPoint-2]-zzp[ExtPoint-1];

     if(zzbar[ExtPoint-3]-(zzbar[ExtPoint-1]-zzbar[ExtPoint-2])<0)
     {
       medtm=Time[0]+(zzbar[ExtPoint-1]-zzbar[ExtPoint-2]-zzbar[ExtPoint-3])*Period()*60;
     }else medtm=Time[zzbar[ExtPoint-3]-(zzbar[ExtPoint-1]-zzbar[ExtPoint-2])];

//        
     k=(zzp[ExtPoint-1]-medpr)/(Time[zzbar[ExtPoint-1]]-medtm); 
     b=medpr-k*medtm;       
     tp=NormalizeDouble(k*Time[zzbar[ExtPoint-3]]+b,Digits);

//  
     if(Scale==0)
     {
       Scale=Scale();
     }
     ObjectCreate("MetroPitchfork",OBJ_PITCHFORK,0,Time[zzbar[ExtPoint-2]],zzp[ExtPoint-2],Time[zzbar[ExtPoint-3]],zzp[ExtPoint-3],Time[zzbar[ExtPoint-3]],2*tp-zzp[ExtPoint-3]);
     ObjectCreate("MetroArc",OBJ_FIBOARC,0,Time[zzbar[ExtPoint-3]],zzp[ExtPoint-3],Time[zzbar[ExtPoint-3]],tp);
     ObjectSet("MetroArc",OBJPROP_ELLIPSE,true);
     ObjectSet("MetroArc",OBJPROP_SCALE,Scale);
     ObjectSet("MetroArc",OBJPROP_FIBOLEVELS,4);
     ObjectSet("MetroArc",OBJPROP_FIRSTLEVEL+0,0.382);
     ObjectSet("MetroArc",OBJPROP_FIRSTLEVEL+1,0.5);
     ObjectSet("MetroArc",OBJPROP_FIRSTLEVEL+2,0.618);
     ObjectSet("MetroArc",OBJPROP_FIRSTLEVEL+3,1.0);
     ObjectSet("MetroArc",OBJPROP_LEVELCOLOR,ExtArcColor);
     ObjectSet("MetroArc",OBJPROP_LEVELSTYLE,ExtArcStyle);
     ObjectSet("MetroArc",OBJPROP_LEVELWIDTH,ExtArcWidth);
   }
   return(0);
  }
//+------------------------------------------------------------------+

double Scale()
{
   double priceRange = WindowPriceMax(0) - WindowPriceMin(0);
   double barsCount = WindowBarsPerChart();
   double chartScale = (priceRange / Point) / barsCount;
   return(chartScale*GPixels/VPixels);
}